import es

####CONFIG####
vff_announce = es.ServerVar("vff_announce", 1, "Message at round start telling people how to vote.")
vff_minplayers = es.ServerVar("vff_minplayers", 4, "Minimum players required to vote.")
vff_percentage = es.ServerVar("vff_percentage", 50, "Percentage of players votes needed to activate/deactivate friendly fire.")
##############

voters = {}
saycmds = ["voteff", "vff"]
es.ServerVar("voteff_ver", "1.0").makepublic()

def player_say(event_var):
    if event_var["text"] in saycmds:
        vote(event_var["userid"])

def round_start(event_var):
    if vff_announce == 1:
        if es.ServerVar("mp_friendlyfire") == 0:
            es.msg("#multi", "#green[VoteFF]#defaultType #greenvoteff#default to vote to activate #lightgreenFriendly Fire#default.")
        else:
            es.msg("#multi", "#green[VoteFF]#defaultType #greenvoteff#default to vote to deactivate #lightgreenFriendly Fire#default.")

def vote(vff_userid):
    global voters
    if es.getplayercount() >= int(vff_minplayers):
        if not es.getplayersteamid(vff_userid) in voters:
            voters[es.getplayersteamid(vff_userid)] = 1
            vff_times = 100 / vff_percentage - 0.01
            vff_players = int(round(es.getplayercount() / vff_times))
            vff_remaining = vff_players - len(voters)
            if vff_remaining <= 0:
                vff_remaining = 0
            if es.ServerVar("mp_friendlyfire") == 1:
                es.msg("#multi", "#green[VoteFF]#lightgreen %s#default voted to deactivate #lightgreenFriendly Fire#default, %d more votes needed." % (es.getplayername(vff_userid), vff_remaining))
            else:
                es.msg("#multi", "#green[VoteFF]#lightgreen %s#default voted to activate #lightgreenFriendly Fire#default, %d more votes needed." % (es.getplayername(vff_userid), vff_remaining))
            if vff_remaining == 0:
                vff_ff = es.ServerVar("mp_friendlyfire")
                if vff_ff == 1:
                    es.forcevalue("mp_friendlyfire", 0)
                    es.msg("#multi", "#green[VoteFF]#default Friendly Fire Deactivated!")
                    voters = {}
                else:
                    es.forcevalue("mp_friendlyfire", 1)
                    es.msg("#multi", "#green[VoteFF]#default Friendly Fire Activated!")
                    voters = {}
        else:
            es.tell(vff_userid, "#multi", "#green[VoteFF]#default You have already voted.")
    else:
        es.tell(vff_userid, "#multi", "#green[VoteFF]#default A minimum of #lightgreen%d #defaultplayers are required to vote." % vff_minplayers)

def es_map_start(event_var):
    global voters
    voters = {}